diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/86xx/mpc8610_hpcd.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/86xx/mpc8610_hpcd.c
--- linux-3.0/arch/powerpc/platforms/86xx/mpc8610_hpcd.c	2011-08-29 03:04:15.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/86xx/mpc8610_hpcd.c	2011-10-18 04:06:23.000000000 +0000
@@ -39,12 +39,19 @@
 #include <sysdev/fsl_pci.h>
 #include <sysdev/fsl_soc.h>
 #include <sysdev/simple_gpio.h>
+#include <asm/fsl_guts.h>
 
 #include "mpc86xx.h"
 
 static struct device_node *pixis_node;
 static unsigned char *pixis_bdcfg0, *pixis_arch;
 
+/* DIU Pixel Clock bits of the CLKDVDR Global Utilities register */
+#define CLKDVDR_PXCKEN		0x80000000
+#define CLKDVDR_PXCKINV		0x10000000
+#define CLKDVDR_PXCKDLY		0x06000000
+#define CLKDVDR_PXCLK_MASK	0x001F0000
+
 #ifdef CONFIG_SUSPEND
 static irqreturn_t mpc8610_sw9_irq(int irq, void *data)
 {
@@ -205,72 +212,54 @@ void mpc8610hpcd_set_monitor_port(int mo
 			     bdcfg[monitor_port]);
 }
 
+/**
+ * mpc8610hpcd_set_pixel_clock: program the DIU's clock
+ *
+ * @pixclock: the wavelength, in picoseconds, of the clock
+ */
 void mpc8610hpcd_set_pixel_clock(unsigned int pixclock)
 {
-	u32 __iomem *clkdvdr;
-	u32 temp;
-	/* variables for pixel clock calcs */
-	ulong  bestval, bestfreq, speed_ccb, minpixclock, maxpixclock;
-	ulong pixval;
-	long err;
-	int i;
+	struct device_node *guts_np = NULL;
+	struct ccsr_guts_86xx __iomem *guts;
+	unsigned long freq;
+	u64 temp;
+	u32 pxclk;
 
-	clkdvdr = ioremap(get_immrbase() + 0xe0800, sizeof(u32));
-	if (!clkdvdr) {
-		printk(KERN_ERR "Err: can't map clock divider register!\n");
+	/* Map the global utilities registers. */
+	guts_np = of_find_compatible_node(NULL, NULL, "fsl,mpc8610-guts");
+	if (!guts_np) {
+		pr_err("mpc8610hpcd: missing global utilties device node\n");
 		return;
 	}
 
-	/* Pixel Clock configuration */
-	speed_ccb = fsl_get_sys_freq();
+	guts = of_iomap(guts_np, 0);
+	of_node_put(guts_np);
+	if (!guts) {
+		pr_err("mpc8610hpcd: could not map global utilties device\n");
+		return;
+	}
 
-	/* Calculate the pixel clock with the smallest error */
-	/* calculate the following in steps to avoid overflow */
-	pr_debug("DIU pixclock in ps - %d\n", pixclock);
-	temp = 1000000000/pixclock;
-	temp *= 1000;
-	pixclock = temp;
-	pr_debug("DIU pixclock freq - %u\n", pixclock);
+	/* Convert pixclock from a wavelength to a frequency */
+	temp = 1000000000000ULL;
+	do_div(temp, pixclock);
+	freq = temp;
 
-	temp = pixclock * 5 / 100;
-	pr_debug("deviation = %d\n", temp);
-	minpixclock = pixclock - temp;
-	maxpixclock = pixclock + temp;
-	pr_debug("DIU minpixclock - %lu\n", minpixclock);
-	pr_debug("DIU maxpixclock - %lu\n", maxpixclock);
-	pixval = speed_ccb/pixclock;
-	pr_debug("DIU pixval = %lu\n", pixval);
+	/*
+	 * 'pxclk' is the ratio of the platform clock to the pixel clock.
+	 * On the MPC8610, the value programmed into CLKDVDR is the ratio
+	 * minus one.  The valid range of values is 2-31.
+	 */
+	pxclk = DIV_ROUND_CLOSEST(fsl_get_sys_freq(), freq) - 1;
+	pxclk = clamp_t(u32, pxclk, 2, 31);
 
-	err = 100000000;
-	bestval = pixval;
-	pr_debug("DIU bestval = %lu\n", bestval);
+	/* Disable the pixel clock, and set it to non-inverted and no delay */
+	clrbits32(&guts->clkdvdr,
+		  CLKDVDR_PXCKEN | CLKDVDR_PXCKDLY | CLKDVDR_PXCLK_MASK);
 
-	bestfreq = 0;
-	for (i = -1; i <= 1; i++) {
-		temp = speed_ccb / ((pixval+i) + 1);
-		pr_debug("DIU test pixval i= %d, pixval=%lu, temp freq. = %u\n",
-							i, pixval, temp);
-		if ((temp < minpixclock) || (temp > maxpixclock))
-			pr_debug("DIU exceeds monitor range (%lu to %lu)\n",
-				minpixclock, maxpixclock);
-		else if (abs(temp - pixclock) < err) {
-		  pr_debug("Entered the else if block %d\n", i);
-			err = abs(temp - pixclock);
-			bestval = pixval+i;
-			bestfreq = temp;
-		}
-	}
+	/* Enable the clock and set the pxclk */
+	setbits32(&guts->clkdvdr, CLKDVDR_PXCKEN | (pxclk << 16));
 
-	pr_debug("DIU chose = %lx\n", bestval);
-	pr_debug("DIU error = %ld\n NomPixClk ", err);
-	pr_debug("DIU: Best Freq = %lx\n", bestfreq);
-	/* Modify PXCLK in GUTS CLKDVDR */
-	pr_debug("DIU: Current value of CLKDVDR = 0x%08x\n", (*clkdvdr));
-	temp = (*clkdvdr) & 0x2000FFFF;
-	*clkdvdr = temp;		/* turn off clock */
-	*clkdvdr = temp | 0x80000000 | (((bestval) & 0x1F) << 16);
-	pr_debug("DIU: Modified value of CLKDVDR = 0x%08x\n", (*clkdvdr));
-	iounmap(clkdvdr);
+	iounmap(guts);
 }
 
 ssize_t mpc8610hpcd_show_monitor_port(int monitor_port, char *buf)
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/Kconfig torvalds-linux-v3.1-rc10/arch/powerpc/platforms/Kconfig
--- linux-3.0/arch/powerpc/platforms/Kconfig	2011-08-29 03:04:15.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -24,7 +24,7 @@ source "arch/powerpc/platforms/wsp/Kconf
 
 config KVM_GUEST
 	bool "KVM Guest support"
-	default y
+	default n
 	---help---
 	  This option enables various optimizations for running under the KVM
 	  hypervisor. Overhead for the kernel when not running inside KVM should
@@ -78,6 +78,10 @@ config MPIC
 	bool
 	default n
 
+config PPC_EPAPR_HV_PIC
+	bool
+	default n
+
 config MPIC_WEIRD
 	bool
 	default n
@@ -266,7 +270,7 @@ config TAU_AVERAGE
 
 config QUICC_ENGINE
 	bool "Freescale QUICC Engine (QE) Support"
-	depends on FSL_SOC
+	depends on FSL_SOC && PPC32
 	select PPC_LIB_RHEAP
 	select CRC32
 	help
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/amigaone/Kconfig torvalds-linux-v3.1-rc10/arch/powerpc/platforms/amigaone/Kconfig
--- linux-3.0/arch/powerpc/platforms/amigaone/Kconfig	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/amigaone/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -8,7 +8,7 @@ config AMIGAONE
 	select NOT_COHERENT_CACHE
 	select CHECK_CACHE_COHERENCY
 	select DEFAULT_UIMAGE
-	select PCSPKR_PLATFORM
+	select HAVE_PCSPKR_PLATFORM
 	help
 	Select AmigaOne for the following machines:
 	- AmigaOne SE/Teron CX (G3 only)
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/cell/celleb_scc_epci.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/celleb_scc_epci.c
--- linux-3.0/arch/powerpc/platforms/cell/celleb_scc_epci.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/celleb_scc_epci.c	2011-10-18 04:06:23.000000000 +0000
@@ -393,19 +393,19 @@ static int __init celleb_setup_epci(stru
 
 	if (of_address_to_resource(node, 0, &r))
 		goto error;
-	hose->cfg_addr = ioremap(r.start, (r.end - r.start + 1));
+	hose->cfg_addr = ioremap(r.start, resource_size(&r));
 	if (!hose->cfg_addr)
 		goto error;
 	pr_debug("EPCI: cfg_addr map 0x%016llx->0x%016lx + 0x%016llx\n",
-		 r.start, (unsigned long)hose->cfg_addr, (r.end - r.start + 1));
+		 r.start, (unsigned long)hose->cfg_addr, resource_size(&r));
 
 	if (of_address_to_resource(node, 2, &r))
 		goto error;
-	hose->cfg_data = ioremap(r.start, (r.end - r.start + 1));
+	hose->cfg_data = ioremap(r.start, resource_size(&r));
 	if (!hose->cfg_data)
 		goto error;
 	pr_debug("EPCI: cfg_data map 0x%016llx->0x%016lx + 0x%016llx\n",
-		 r.start, (unsigned long)hose->cfg_data, (r.end - r.start + 1));
+		 r.start, (unsigned long)hose->cfg_data, resource_size(&r));
 
 	hose->ops = &celleb_epci_ops;
 	celleb_epci_init(hose);
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/cell/celleb_scc_pciex.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/celleb_scc_pciex.c
--- linux-3.0/arch/powerpc/platforms/cell/celleb_scc_pciex.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/celleb_scc_pciex.c	2011-10-18 04:06:23.000000000 +0000
@@ -494,7 +494,7 @@ static __init int celleb_setup_pciex(str
 		pr_err("PCIEXC:Failed to get config resource.\n");
 		return 1;
 	}
-	phb->cfg_addr = ioremap(r.start, r.end - r.start + 1);
+	phb->cfg_addr = ioremap(r.start, resource_size(&r));
 	if (!phb->cfg_addr) {
 		pr_err("PCIEXC:Failed to remap SMMIO region.\n");
 		return 1;
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/cell/cpufreq_spudemand.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/cpufreq_spudemand.c
--- linux-3.0/arch/powerpc/platforms/cell/cpufreq_spudemand.c	2011-04-03 18:50:34.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/cpufreq_spudemand.c	2011-10-18 04:06:23.000000000 +0000
@@ -24,7 +24,7 @@
 #include <linux/sched.h>
 #include <linux/timer.h>
 #include <linux/workqueue.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/machdep.h>
 #include <asm/spu.h>
 
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/cell/smp.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/smp.c
--- linux-3.0/arch/powerpc/platforms/cell/smp.c	2011-08-29 03:04:15.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/smp.c	2011-10-18 04:06:23.000000000 +0000
@@ -28,7 +28,7 @@
 #include <linux/cpu.h>
 
 #include <asm/ptrace.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/irq.h>
 #include <asm/page.h>
 #include <asm/pgtable.h>
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/cell/spu_manage.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/spu_manage.c
--- linux-3.0/arch/powerpc/platforms/cell/spu_manage.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/spu_manage.c	2011-10-18 04:06:23.000000000 +0000
@@ -222,7 +222,7 @@ static int spu_map_resource(struct spu *
 		return ret;
 	if (phys)
 		*phys = resource.start;
-	len = resource.end - resource.start + 1;
+	len = resource_size(&resource);
 	*virt = ioremap(resource.start, len);
 	if (!*virt)
 		return -EINVAL;
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/cell/spufs/context.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/spufs/context.c
--- linux-3.0/arch/powerpc/platforms/cell/spufs/context.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/spufs/context.c	2011-10-18 04:06:23.000000000 +0000
@@ -24,7 +24,7 @@
 #include <linux/mm.h>
 #include <linux/module.h>
 #include <linux/slab.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/spu.h>
 #include <asm/spu_csa.h>
 #include "spufs.h"
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/cell/spufs/file.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/spufs/file.c
--- linux-3.0/arch/powerpc/platforms/cell/spufs/file.c	2011-04-03 18:50:34.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/spufs/file.c	2011-10-18 04:06:23.000000000 +0000
@@ -1850,9 +1850,16 @@ out:
 	return ret;
 }
 
-static int spufs_mfc_fsync(struct file *file, int datasync)
+static int spufs_mfc_fsync(struct file *file, loff_t start, loff_t end, int datasync)
 {
-	return spufs_mfc_flush(file, NULL);
+	struct inode *inode = file->f_path.dentry->d_inode;
+	int err = filemap_write_and_wait_range(inode->i_mapping, start, end);
+	if (!err) {
+		mutex_lock(&inode->i_mutex);
+		err = spufs_mfc_flush(file, NULL);
+		mutex_unlock(&inode->i_mutex);
+	}
+	return err;
 }
 
 static int spufs_mfc_fasync(int fd, struct file *file, int on)
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/cell/spufs/inode.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/spufs/inode.c
--- linux-3.0/arch/powerpc/platforms/cell/spufs/inode.c	2011-04-03 18:50:34.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/spufs/inode.c	2011-10-18 04:06:23.000000000 +0000
@@ -611,15 +611,14 @@ out:
 
 static struct file_system_type spufs_type;
 
-long spufs_create(struct nameidata *nd, unsigned int flags, mode_t mode,
-							struct file *filp)
+long spufs_create(struct path *path, struct dentry *dentry,
+		unsigned int flags, mode_t mode, struct file *filp)
 {
-	struct dentry *dentry;
 	int ret;
 
 	ret = -EINVAL;
 	/* check if we are on spufs */
-	if (nd->path.dentry->d_sb->s_type != &spufs_type)
+	if (path->dentry->d_sb->s_type != &spufs_type)
 		goto out;
 
 	/* don't accept undefined flags */
@@ -627,33 +626,27 @@ long spufs_create(struct nameidata *nd,
 		goto out;
 
 	/* only threads can be underneath a gang */
-	if (nd->path.dentry != nd->path.dentry->d_sb->s_root) {
+	if (path->dentry != path->dentry->d_sb->s_root) {
 		if ((flags & SPU_CREATE_GANG) ||
-		    !SPUFS_I(nd->path.dentry->d_inode)->i_gang)
+		    !SPUFS_I(path->dentry->d_inode)->i_gang)
 			goto out;
 	}
 
-	dentry = lookup_create(nd, 1);
-	ret = PTR_ERR(dentry);
-	if (IS_ERR(dentry))
-		goto out_dir;
-
 	mode &= ~current_umask();
 
 	if (flags & SPU_CREATE_GANG)
-		ret = spufs_create_gang(nd->path.dentry->d_inode,
-					 dentry, nd->path.mnt, mode);
+		ret = spufs_create_gang(path->dentry->d_inode,
+					 dentry, path->mnt, mode);
 	else
-		ret = spufs_create_context(nd->path.dentry->d_inode,
-					    dentry, nd->path.mnt, flags, mode,
+		ret = spufs_create_context(path->dentry->d_inode,
+					    dentry, path->mnt, flags, mode,
 					    filp);
 	if (ret >= 0)
-		fsnotify_mkdir(nd->path.dentry->d_inode, dentry);
+		fsnotify_mkdir(path->dentry->d_inode, dentry);
 	return ret;
 
-out_dir:
-	mutex_unlock(&nd->path.dentry->d_inode->i_mutex);
 out:
+	mutex_unlock(&path->dentry->d_inode->i_mutex);
 	return ret;
 }
 
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/cell/spufs/spufs.h torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/spufs/spufs.h
--- linux-3.0/arch/powerpc/platforms/cell/spufs/spufs.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/spufs/spufs.h	2011-10-18 04:06:23.000000000 +0000
@@ -248,7 +248,7 @@ extern const struct spufs_tree_descr spu
 /* system call implementation */
 extern struct spufs_calls spufs_calls;
 long spufs_run_spu(struct spu_context *ctx, u32 *npc, u32 *status);
-long spufs_create(struct nameidata *nd, unsigned int flags,
+long spufs_create(struct path *nd, struct dentry *dentry, unsigned int flags,
 			mode_t mode, struct file *filp);
 /* ELF coredump callbacks for writing SPU ELF notes */
 extern int spufs_coredump_extra_notes_size(void);
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/cell/spufs/syscalls.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/spufs/syscalls.c
--- linux-3.0/arch/powerpc/platforms/cell/spufs/syscalls.c	2011-06-22 15:08:08.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/cell/spufs/syscalls.c	2011-10-18 04:06:23.000000000 +0000
@@ -62,21 +62,17 @@ out:
 static long do_spu_create(const char __user *pathname, unsigned int flags,
 		mode_t mode, struct file *neighbor)
 {
-	char *tmp;
+	struct path path;
+	struct dentry *dentry;
 	int ret;
 
-	tmp = getname(pathname);
-	ret = PTR_ERR(tmp);
-	if (!IS_ERR(tmp)) {
-		struct nameidata nd;
-
-		ret = kern_path_parent(tmp, &nd);
-		if (!ret) {
-			nd.flags |= LOOKUP_OPEN | LOOKUP_CREATE;
-			ret = spufs_create(&nd, flags, mode, neighbor);
-			path_put(&nd.path);
-		}
-		putname(tmp);
+	dentry = user_path_create(AT_FDCWD, pathname, &path, 1);
+	ret = PTR_ERR(dentry);
+	if (!IS_ERR(dentry)) {
+		ret = spufs_create(&path, dentry, flags, mode, neighbor);
+		mutex_unlock(&path.dentry->d_inode->i_mutex);
+		dput(dentry);
+		path_put(&path);
 	}
 
 	return ret;
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/chrp/Kconfig torvalds-linux-v3.1-rc10/arch/powerpc/platforms/chrp/Kconfig
--- linux-3.0/arch/powerpc/platforms/chrp/Kconfig	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/chrp/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -1,6 +1,7 @@
 config PPC_CHRP
 	bool "Common Hardware Reference Platform (CHRP) based machines"
 	depends on 6xx
+	select HAVE_PCSPKR_PLATFORM
 	select MPIC
 	select PPC_I8259
 	select PPC_INDIRECT_PCI
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/chrp/pci.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/chrp/pci.c
--- linux-3.0/arch/powerpc/platforms/chrp/pci.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/chrp/pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -142,7 +142,7 @@ hydra_init(void)
 		return 0;
 	}
 	of_node_put(np);
-	Hydra = ioremap(r.start, r.end-r.start);
+	Hydra = ioremap(r.start, resource_size(&r));
 	printk("Hydra Mac I/O at %llx\n", (unsigned long long)r.start);
 	printk("Hydra Feature_Control was %x",
 	       in_le32(&Hydra->Feature_Control));
@@ -199,7 +199,7 @@ static void __init setup_peg2(struct pci
 		printk ("RTAS supporting Pegasos OF not found, please upgrade"
 			" your firmware\n");
 	}
-	ppc_pci_add_flags(PPC_PCI_REASSIGN_ALL_BUS);
+	pci_add_flags(PCI_REASSIGN_ALL_BUS);
 	/* keep the reference to the root node */
 }
 
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/chrp/smp.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/chrp/smp.c
--- linux-3.0/arch/powerpc/platforms/chrp/smp.c	2011-08-29 03:04:15.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/chrp/smp.c	2011-10-18 04:06:23.000000000 +0000
@@ -18,7 +18,7 @@
 #include <linux/spinlock.h>
 
 #include <asm/ptrace.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/irq.h>
 #include <asm/page.h>
 #include <asm/pgtable.h>
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/iseries/exception.S torvalds-linux-v3.1-rc10/arch/powerpc/platforms/iseries/exception.S
--- linux-3.0/arch/powerpc/platforms/iseries/exception.S	2011-08-29 03:04:16.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/iseries/exception.S	2011-10-18 04:06:23.000000000 +0000
@@ -167,7 +167,7 @@ BEGIN_FTR_SECTION
 	std	r12,PACA_EXGEN+EX_R13(r13)
 	EXCEPTION_PROLOG_ISERIES_1
 FTR_SECTION_ELSE
-	EXCEPTION_PROLOG_1(PACA_EXGEN)
+	EXCEPTION_PROLOG_1(PACA_EXGEN, NOTEST, 0)
 	EXCEPTION_PROLOG_ISERIES_1
 ALT_MMU_FTR_SECTION_END_IFCLR(MMU_FTR_SLB)
 	b	data_access_common
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/iseries/exception.h torvalds-linux-v3.1-rc10/arch/powerpc/platforms/iseries/exception.h
--- linux-3.0/arch/powerpc/platforms/iseries/exception.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/iseries/exception.h	2011-10-18 04:06:23.000000000 +0000
@@ -39,7 +39,7 @@
 label##_iSeries:							\
 	HMT_MEDIUM;							\
 	mtspr	SPRN_SPRG_SCRATCH0,r13;	/* save r13 */			\
-	EXCEPTION_PROLOG_1(area);					\
+	EXCEPTION_PROLOG_1(area, NOTEST, 0);				\
 	EXCEPTION_PROLOG_ISERIES_1;					\
 	b	label##_common
 
@@ -48,7 +48,7 @@ label##_iSeries:							\
 label##_iSeries:							\
 	HMT_MEDIUM;							\
 	mtspr	SPRN_SPRG_SCRATCH0,r13;	/* save r13 */			\
-	EXCEPTION_PROLOG_1(PACA_EXGEN);					\
+	EXCEPTION_PROLOG_1(PACA_EXGEN, NOTEST, 0);			\
 	lbz	r10,PACASOFTIRQEN(r13);					\
 	cmpwi	0,r10,0;						\
 	beq-	label##_iSeries_masked;					\
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/iseries/smp.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/iseries/smp.c
--- linux-3.0/arch/powerpc/platforms/iseries/smp.c	2011-08-29 03:04:16.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/iseries/smp.c	2011-10-18 04:06:23.000000000 +0000
@@ -29,7 +29,7 @@
 #include <linux/cpu.h>
 
 #include <asm/ptrace.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/irq.h>
 #include <asm/page.h>
 #include <asm/pgtable.h>
@@ -75,7 +75,7 @@ static void __devinit smp_iSeries_setup_
 }
 
 static struct smp_ops_t iSeries_smp_ops = {
-	.message_pass = smp_muxed_ipi_message_pass,
+	.message_pass = NULL,	/* Use smp_muxed_ipi_message_pass */
 	.cause_ipi    = smp_iSeries_cause_ipi,
 	.probe        = smp_iSeries_probe,
 	.kick_cpu     = smp_iSeries_kick_cpu,
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/maple/setup.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/maple/setup.c
--- linux-3.0/arch/powerpc/platforms/maple/setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/maple/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -338,35 +338,16 @@ define_machine(maple) {
 #ifdef CONFIG_EDAC
 /*
  * Register a platform device for CPC925 memory controller on
- * Motorola ATCA-6101 blade.
+ * all boards with U3H (CPC925) bridge.
  */
-#define MAPLE_CPC925_MODEL	"Motorola,ATCA-6101"
 static int __init maple_cpc925_edac_setup(void)
 {
 	struct platform_device *pdev;
 	struct device_node *np = NULL;
 	struct resource r;
-	const unsigned char *model;
 	int ret;
-
-	np = of_find_node_by_path("/");
-	if (!np) {
-		printk(KERN_ERR "%s: Unable to get root node\n", __func__);
-		return -ENODEV;
-	}
-
-	model = (const unsigned char *)of_get_property(np, "model", NULL);
-	if (!model) {
-		printk(KERN_ERR "%s: Unabel to get model info\n", __func__);
-		of_node_put(np);
-		return -ENODEV;
-	}
-
-	ret = strcmp(model, MAPLE_CPC925_MODEL);
-	of_node_put(np);
-
-	if (ret != 0)
-		return 0;
+	volatile void __iomem *mem;
+	u32 rev;
 
 	np = of_find_node_by_type(NULL, "memory-controller");
 	if (!np) {
@@ -384,6 +365,22 @@ static int __init maple_cpc925_edac_setu
 		return -ENODEV;
 	}
 
+	mem = ioremap(r.start, resource_size(&r));
+	if (!mem) {
+		printk(KERN_ERR "%s: Unable to map memory-controller memory\n",
+				__func__);
+		return -ENOMEM;
+	}
+
+	rev = __raw_readl(mem);
+	iounmap(mem);
+
+	if (rev < 0x34 || rev > 0x3f) { /* U3H */
+		printk(KERN_ERR "%s: Non-CPC925(U3H) bridge revision: %02x\n",
+			__func__, rev);
+		return 0;
+	}
+
 	pdev = platform_device_register_simple("cpc925_edac", 0, &r, 1);
 	if (IS_ERR(pdev))
 		return PTR_ERR(pdev);
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/pasemi/dma_lib.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/pasemi/dma_lib.c
--- linux-3.0/arch/powerpc/platforms/pasemi/dma_lib.c	2011-06-22 15:08:08.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/pasemi/dma_lib.c	2011-10-18 04:06:23.000000000 +0000
@@ -576,7 +576,7 @@ int pasemi_dma_init(void)
 		res.start = 0xfd800000;
 		res.end = res.start + 0x1000;
 	}
-	dma_status = __ioremap(res.start, res.end-res.start, 0);
+	dma_status = __ioremap(res.start, resource_size(&res), 0);
 	pci_dev_put(iob_pdev);
 
 	for (i = 0; i < MAX_TXCH; i++)
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/powermac/backlight.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/powermac/backlight.c
--- linux-3.0/arch/powerpc/platforms/powermac/backlight.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/powermac/backlight.c	2011-10-18 04:06:23.000000000 +0000
@@ -12,7 +12,7 @@
 #include <linux/backlight.h>
 #include <linux/adb.h>
 #include <linux/pmu.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/prom.h>
 #include <asm/backlight.h>
 
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/powermac/nvram.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/powermac/nvram.c
--- linux-3.0/arch/powerpc/platforms/powermac/nvram.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/powermac/nvram.c	2011-10-18 04:06:23.000000000 +0000
@@ -580,10 +580,10 @@ int __init pmac_nvram_init(void)
 	/* Try to obtain an address */
 	if (of_address_to_resource(dp, 0, &r1) == 0) {
 		nvram_naddrs = 1;
-		s1 = (r1.end - r1.start) + 1;
+		s1 = resource_size(&r1);
 		if (of_address_to_resource(dp, 1, &r2) == 0) {
 			nvram_naddrs = 2;
-			s2 = (r2.end - r2.start) + 1;
+			s2 = resource_size(&r2);
 		}
 	}
 
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/powermac/pci.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/powermac/pci.c
--- linux-3.0/arch/powerpc/platforms/powermac/pci.c	2011-06-22 15:08:08.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/powermac/pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -17,6 +17,7 @@
 #include <linux/init.h>
 #include <linux/bootmem.h>
 #include <linux/irq.h>
+#include <linux/of_pci.h>
 
 #include <asm/sections.h>
 #include <asm/io.h>
@@ -235,7 +236,7 @@ static int chaos_validate_dev(struct pci
 
 	if (offset >= 0x100)
 		return  PCIBIOS_BAD_REGISTER_NUMBER;
-	np = pci_busdev_to_OF_node(bus, devfn);
+	np = of_pci_find_child_device(bus->dev.of_node, devfn);
 	if (np == NULL)
 		return PCIBIOS_DEVICE_NOT_FOUND;
 
@@ -560,6 +561,20 @@ static struct pci_ops u4_pcie_pci_ops =
 	.write = u4_pcie_write_config,
 };
 
+static void __devinit pmac_pci_fixup_u4_of_node(struct pci_dev *dev)
+{
+	/* Apple's device-tree "hides" the root complex virtual P2P bridge
+	 * on U4. However, Linux sees it, causing the PCI <-> OF matching
+	 * code to fail to properly match devices below it. This works around
+	 * it by setting the node of the bridge to point to the PHB node,
+	 * which is not entirely correct but fixes the matching code and
+	 * doesn't break anything else. It's also the simplest possible fix.
+	 */
+	if (dev->dev.of_node == NULL)
+		dev->dev.of_node = pcibios_get_phb_of_node(dev->bus);
+}
+DECLARE_PCI_FIXUP_HEADER(PCI_VENDOR_ID_APPLE, 0x5b, pmac_pci_fixup_u4_of_node);
+
 #endif /* CONFIG_PPC64 */
 
 #ifdef CONFIG_PPC32
@@ -731,7 +746,7 @@ static void __init setup_bandit(struct p
 static int __init setup_uninorth(struct pci_controller *hose,
 				 struct resource *addr)
 {
-	ppc_pci_add_flags(PPC_PCI_REASSIGN_ALL_BUS);
+	pci_add_flags(PCI_REASSIGN_ALL_BUS);
 	has_uninorth = 1;
 	hose->ops = &macrisc_pci_ops;
 	hose->cfg_addr = ioremap(addr->start + 0x800000, 0x1000);
@@ -838,8 +853,7 @@ static void __init setup_u3_ht(struct pc
 	 * into cfg_addr
 	 */
 	hose->cfg_data = ioremap(cfg_res.start, 0x02000000);
-	hose->cfg_addr = ioremap(self_res.start,
-				 self_res.end - self_res.start + 1);
+	hose->cfg_addr = ioremap(self_res.start, resource_size(&self_res));
 
 	/*
 	 * /ht node doesn't expose a "ranges" property, we read the register
@@ -998,7 +1012,7 @@ void __init pmac_pci_init(void)
 	struct device_node *np, *root;
 	struct device_node *ht = NULL;
 
-	ppc_pci_set_flags(PPC_PCI_CAN_SKIP_ISA_ALIGN);
+	pci_set_flags(PCI_CAN_SKIP_ISA_ALIGN);
 
 	root = of_find_node_by_path("/");
 	if (root == NULL) {
@@ -1057,7 +1071,7 @@ void __init pmac_pci_init(void)
 	 * some offset between bus number and domains for now when we
 	 * assign all busses should help for now
 	 */
-	if (ppc_pci_has_flag(PPC_PCI_REASSIGN_ALL_BUS))
+	if (pci_has_flag(PCI_REASSIGN_ALL_BUS))
 		pcibios_assign_bus_offset = 0x10;
 #endif
 }
@@ -1323,8 +1337,7 @@ static void fixup_u4_pcie(struct pci_dev
 		 */
 		if (r->start >= 0xf0000000 && r->start < 0xf3000000)
 			continue;
-		if (!region || (r->end - r->start) >
-		    (region->end - region->start))
+		if (!region || resource_size(r) > resource_size(region))
 			region = r;
 	}
 	/* Nothing found, bail */
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/powermac/setup.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/powermac/setup.c
--- linux-3.0/arch/powerpc/platforms/powermac/setup.c	2011-06-22 15:08:08.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/powermac/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -355,9 +355,6 @@ static int initializing = 1;
 static int pmac_late_init(void)
 {
 	initializing = 0;
-	/* this is udbg (which is __init) and we can later use it during
-	 * cpu hotplug (in smp_core99_kick_cpu) */
-	ppc_md.progress = NULL;
 	return 0;
 }
 machine_late_initcall(powermac, pmac_late_init);
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/powermac/smp.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/powermac/smp.c
--- linux-3.0/arch/powerpc/platforms/powermac/smp.c	2011-08-29 03:04:16.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/powermac/smp.c	2011-10-18 04:06:23.000000000 +0000
@@ -35,7 +35,7 @@
 #include <linux/compiler.h>
 
 #include <asm/ptrace.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/code-patching.h>
 #include <asm/irq.h>
 #include <asm/page.h>
@@ -447,7 +447,7 @@ void __init smp_psurge_give_timebase(voi
 
 /* PowerSurge-style Macs */
 struct smp_ops_t psurge_smp_ops = {
-	.message_pass	= smp_muxed_ipi_message_pass,
+	.message_pass	= NULL,	/* Use smp_muxed_ipi_message_pass */
 	.cause_ipi	= smp_psurge_cause_ipi,
 	.probe		= smp_psurge_probe,
 	.kick_cpu	= smp_psurge_kick_cpu,
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/powermac/time.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/powermac/time.c
--- linux-3.0/arch/powerpc/platforms/powermac/time.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/powermac/time.c	2011-10-18 04:06:23.000000000 +0000
@@ -274,7 +274,7 @@ int __init via_calibrate_decr(void)
 		return 0;
 	}
 	of_node_put(vias);
-	via = ioremap(rsrc.start, rsrc.end - rsrc.start + 1);
+	via = ioremap(rsrc.start, resource_size(&rsrc));
 	if (via == NULL) {
 		printk(KERN_ERR "Failed to map VIA for timer calibration !\n");
 		return 0;
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/prep/Kconfig torvalds-linux-v3.1-rc10/arch/powerpc/platforms/prep/Kconfig
--- linux-3.0/arch/powerpc/platforms/prep/Kconfig	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/prep/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -1,6 +1,7 @@
 config PPC_PREP
 	bool "PowerPC Reference Platform (PReP) based machines"
 	depends on 6xx && BROKEN
+	select HAVE_PCSPKR_PLATFORM
 	select MPIC
 	select PPC_I8259
 	select PPC_INDIRECT_PCI
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/pseries/Kconfig torvalds-linux-v3.1-rc10/arch/powerpc/platforms/pseries/Kconfig
--- linux-3.0/arch/powerpc/platforms/pseries/Kconfig	2011-08-29 03:04:16.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/pseries/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -1,6 +1,7 @@
 config PPC_PSERIES
 	depends on PPC64 && PPC_BOOK3S
 	bool "IBM pSeries & new (POWER5-based) iSeries"
+	select HAVE_PCSPKR_PLATFORM
 	select MPIC
 	select PCI_MSI
 	select PPC_XICS
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/pseries/dlpar.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/pseries/dlpar.c
--- linux-3.0/arch/powerpc/platforms/pseries/dlpar.c	2011-06-22 15:08:08.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/pseries/dlpar.c	2011-10-18 04:06:23.000000000 +0000
@@ -262,12 +262,11 @@ int dlpar_attach_node(struct device_node
 	if (!dn->parent)
 		return -ENOMEM;
 
-	rc = blocking_notifier_call_chain(&pSeries_reconfig_chain,
-					  PSERIES_RECONFIG_ADD, dn);
-	if (rc == NOTIFY_BAD) {
+	rc = pSeries_reconfig_notify(PSERIES_RECONFIG_ADD, dn);
+	if (rc) {
 		printk(KERN_ERR "Failed to add device node %s\n",
 		       dn->full_name);
-		return -ENOMEM; /* For now, safe to assume kmalloc failure */
+		return rc;
 	}
 
 	of_attach_node(dn);
@@ -297,8 +296,7 @@ int dlpar_detach_node(struct device_node
 		remove_proc_entry(dn->pde->name, parent->pde);
 #endif
 
-	blocking_notifier_call_chain(&pSeries_reconfig_chain,
-			    PSERIES_RECONFIG_REMOVE, dn);
+	pSeries_reconfig_notify(PSERIES_RECONFIG_REMOVE, dn);
 	of_detach_node(dn);
 	of_node_put(dn); /* Must decrement the refcount */
 
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/pseries/dtl.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/pseries/dtl.c
--- linux-3.0/arch/powerpc/platforms/pseries/dtl.c	2011-08-29 03:04:16.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/pseries/dtl.c	2011-10-18 04:06:23.000000000 +0000
@@ -181,7 +181,7 @@ static void dtl_stop(struct dtl *dtl)
 
 	lppaca_of(dtl->cpu).dtl_enable_mask = 0x0;
 
-	unregister_dtl(hwcpu, __pa(dtl->buf));
+	unregister_dtl(hwcpu);
 }
 
 static u64 dtl_current_index(struct dtl *dtl)
diff -NurpP --minimal linux-3.0/arch/powerpc/platforms/pseries/eeh.c torvalds-linux-v3.1-rc10/arch/powerpc/platforms/pseries/eeh.c
--- linux-3.0/arch/powerpc/platforms/pseries/eeh.c	2011-08-29 03:04:16.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/powerpc/platforms/pseries/eeh.c	2011-10-18 04:06:23.000000000 +0000
@@ -31,7 +31,7 @@
 #include <linux/spinlock.h>
 #include <linux/of.h>
 
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/eeh.h>
 #include <asm/eeh_event.h>
 #include <asm/io.h>
